<script setup lang="ts">
import { usePassportStore } from "../../../stores/passport";
import { VaInput, VaSelect, VaDateInput } from "vuestic-ui";
import { ref, computed } from "vue";
import { errors, lettersRegex } from "../../../constants";
const passportStore = usePassportStore();
const passportState = passportStore.$state.passport;

const personalData = ref({
  name: passportState.name,
  surname: passportState.surname,
  personal_id: passportState.personal_id,
  sex: passportState.sex,
  birth_date: passportState.birth_date,
});

const fieldsErrors = computed(() => ({
  name: {
    isError: !lettersRegex.test(personalData.value.name),
    errorMessage: errors.lettersOnly,
  },
  surname: {
    isError: !lettersRegex.test(personalData.value.surname),
    errorMessage: errors.lettersOnly,
  },
  personal_id: (() => {
    const numbersRegex = /^\d+$/;
    const lengthIsNotCorrect = personalData.value.personal_id.length !== 11;
    const sexNotMatchPersonalId =
      personalData.value.personal_id[0] !==
      (personalData.value.sex === "MOT/F" ? "4" : "3");
    const notOnlyNumbers = !numbersRegex.test(personalData.value.personal_id);

    return {
      isError: lengthIsNotCorrect || sexNotMatchPersonalId || notOnlyNumbers,
      errorMessage:
        (lengthIsNotCorrect && errors.personalIdLength) ||
        (sexNotMatchPersonalId && errors.personalIdSexMatch) ||
        (notOnlyNumbers && errors.numbersOnly) ||
        "",
    };
  })(),
}));

const submitForm = () => {
  passportStore.updatePassport({ ...personalData.value });
};
</script>

<template>
  <div class="FormPersonal">
    <div class="documentData">
      <div class="image">
        <img :src="passportState.image" />
      </div>
      <div class="form">
        <div class="column">
          <VaInput
            label="Name"
            v-model="personalData.name"
            :error="fieldsErrors.name.isError"
            :error-messages="fieldsErrors.name.errorMessage"
          />
          <VaInput
            label="Surname"
            v-model="personalData.surname"
            :error="fieldsErrors.surname.isError"
            :error-messages="fieldsErrors.surname.errorMessage"
          />
          <VaSelect
            label="Sex"
            :options="['MOT\/F', 'VYR\/M']"
            v-model="personalData.sex"
          />
        </div>
        <div class="column">
          <VaInput
            label="Personal Id"
            v-model="personalData.personal_id"
            :error="fieldsErrors.personal_id.isError"
            :error-messages="fieldsErrors.personal_id.errorMessage"
          />
          <VaDateInput label="Birth Date" v-model="personalData.birth_date" />
        </div>
      </div>
    </div>
    <div class="saveButtonWrap">
      <VaButton
        :disabled="Object.values(fieldsErrors).some(({ isError }) => isError)"
        @click="submitForm"
      >
        Save
      </VaButton>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.FormPersonal {
  padding: 1rem;

  .documentData {
    display: flex;
  }

  .image {
    width: 30%;
    padding: 0.5rem;
    img {
      width: 100%;
    }
  }
  .form {
    display: flex;
    padding: 0.5rem;
    width: 70%;

    .va-input-wrapper,
    .va-date-input,
    .va-dropdown {
      margin-bottom: 0.5rem;
      width: 100%;
    }
    .column {
      width: 50%;
      padding: 0 0.5rem;
    }
  }

  .saveButtonWrap {
    display: flex;
    justify-content: flex-end;
    padding: 1rem;
  }

  @media (max-width: 768px) {
    .image {
      width: 100%;
    }
    .form {
      width: 100%;
      flex-direction: column;
      .column {
        width: 100%;
      }
    }
  }
  @media (max-width: 480px) {
    .documentData {
      display: flex;
      flex-direction: column;
    }
  }
}
</style>
